<template>
  <v-container>
    <v-row>
      <v-col>
        <p class="title">Profile</p>
        <span>This is your front page, where client can find you</span>
      </v-col>
      <v-col class="text-right">
        <v-btn small color="secondary" class="mr-2">Share</v-btn>
        <v-btn small color="primary" :to="`/facilitators/${updateProfileAttr.id}`" target="_blank">View profile</v-btn>
      </v-col>
    </v-row>
    <v-row>
      <v-col xs="12" sm="4" md="3" class="pt-10">
        <image-upload :initial-image="updateProfileAttr.imageUrl" />
        <p>Licensed therapist</p>
        <v-checkbox dense v-model="updateProfileAttr.licensedTherapist" label="I am a Licensed Therapist"/>
      </v-col>

      <v-col xs="12" sm="8" md="9" class="mt-10">
        <p>Title</p>
        <v-text-field
          v-model="updateProfileAttr.title"
          outlined
          required
          placeholder="Title"
          hide-details
          class="mb-5"
        />
        
        <p>About</p>
        <v-textarea
          v-model="updateProfileAttr.about"
          outlined
          placeholder="Tell us about yourself "
          required
        /> 

        <p>Circle types</p>
        <v-card outlined class="mb-6">
          <v-card-text>
            <v-row
              v-for="(circleType, index) in updateProfileAttr.circleTypes"
              :key="index"
            >
              <v-col>
                <span class="body-1">{{ circleType }}</span>
              </v-col>
              <v-col class="text-right">
                <v-btn icon>
                  <v-icon>mdi-minus-circle-outline</v-icon>
                </v-btn>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <p>Add more circle types</p>
                <circle-types-select
                  dense
                  :multiple="false"
                  :add-circle-type="type => updateCircleTypes(type)"
                />
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>

        <p>Experiences</p>
        <v-card outlined class="mb-6">
          <v-card-text>
            <v-row
              v-for="(experience, index) in updateProfileAttr.experiences"
              :key="index"
            >
              <v-col>
                <span class="body-1">{{ experience }}</span>
              </v-col>
              <v-col class="text-right">
                <v-btn icon>
                  <v-icon>mdi-minus-circle-outline</v-icon>
                </v-btn>
              </v-col>
            </v-row>
            <v-row>
              <v-col>
                <p>Add more Experiences</p>
                <ExperienceSelect
                  :label="'Add an Experience'"
                  :multiple="false"
                  :update-experience="
                    experience => updateExperiences(experience)
                  "
                />
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
        
        <p>Client Focus</p>
        <v-card outlined class="mb-6">
          <v-card-text>
            <label class="mb-2">Age</label>
            <v-select
                :items="AGES"
                multiple
                outlined
                dense
                hide-details="auto"
                v-model="updateProfileAttr.ages"
                class="mb-6"
              />
            <label>Communities</label>
            <v-select
              :items="COMMUNITIES"
              multiple
              outlined
              dense
              hide-details="auto"
              v-model="updateProfileAttr.communities"
              class="mb-6"
            />
          </v-card-text>
        </v-card>
        
        <v-btn
          :loading="loading"
          color="primary"
          style="width: 100%"
          @click="updateProfile"
          >Update profile</v-btn
        >
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import { mapState, mapActions } from 'vuex'
import ExperienceSelect from '@/components/Shared/UI/ExperienceSelect'
import CircleTypesSelect from '@/components/Shared/UI/CircleTypesSelect'
import ImageUpload from '@/components/Shared/ImageUpload'
import { AGES, COMMUNITIES } from '@/constants'

export default {
  name: 'FacilitatorAccount',
  components: {
    ImageUpload,
    ExperienceSelect,
    CircleTypesSelect
  },
  data: () => ({
    updateProfileAttr: {},
    valid: false,
    loading: false,
    Languages: [],
    AGES,
    COMMUNITIES
  }),
  computed: {
    ...mapState('facilitatorProfile', ['facilitatorProfile']),
    ...mapState('authentication', ['user'])
  },
  watch: {
    facilitatorProfile: {
      handler(profile) {
        this.updateProfileAttr = { ...profile }
      }
    }
  },
  beforeMount() {
    this.getFacilitatorProfile(this.user.id)
  },
  mounted() {
    this.updateProfileAttr = { ...this.facilitatorProfile }
  },
  methods: {
    ...mapActions('facilitatorProfile', ['getFacilitatorProfile', 'update']),
    updateProfile() {
      // this.update(this.updateProfileAttr)
      this.loading = true
      this.$store
        .dispatch('facilitatorProfile/update', this.updateProfileAttr)
        .then(() => {
          this.loading = false
          this.$router.push({ path: '/facilitator' })
        })
        .catch(() => {
          this.loading = false
        })
    },
    updateExperiences(experience) {
      let exists = false
      this.updateProfileAttr.experiences.forEach(exp => {
        if (exp === experience) {
          exists = true
        }
      })
      if (!exists) {
        this.updateProfileAttr.experiences.push(experience)
      }
    },
    updateCircleTypes(circleType) {
      let exists = false
      this.updateProfileAttr.circleTypes.forEach(type => {
        if (type === circleType) {
          exists = true
        }
      })
      if (!exists) {
        this.updateProfileAttr.circleTypes.push(circleType)
      }
    }
  }
}
</script>

<style scoped></style>
